//************************************************************************************************************
// main.cpp : Ein Hallo-Welt-Programm (Endlosschleife mit Ausgabe auf die serielle Schnittstelle).
// Wenn nderungen am Programm, welches der Bytecode-Interpreter ausfhren soll, vorgenommen werden sollen,
// muss unten zum einen das Array mem[] mit dem neuen Bytecode ersetzt werden, und zum anderen 
// muss die neue Startadresse der auszufhrenden Funktion bei der Anweisung ip.execute_bytecode( ... );
// bergeben werden (diese Anweisung steht unten in main2()).
//************************************************************************************************************

#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <avr/pgmspace.h>

extern "C"
{
#include "usart.h"
}

#include "BytecodeInterpreter.h"

using BytecodeInterpreter::Value;
using BytecodeInterpreter::uint8;
using BytecodeInterpreter::uint16;
using BytecodeInterpreter::uint32;
using BytecodeInterpreter::uint64;
using BytecodeInterpreter::int8;
using BytecodeInterpreter::int16;
using BytecodeInterpreter::int32;
using BytecodeInterpreter::int64;

namespace extern_function_names { enum
{	// C/C++ - Funktionen, die vom Programm, welches auf dem Bytecode-Interpreter luft, aufgerufen werden knnen
	// ("externe Funktionen").
	prints
}; };

void extern_function_invoker(VARIABLE_INDEX_TYPE function_number, BytecodeInterpreter::BytecodeInterpreter& ip)
{
	namespace nn=extern_function_names;
	switch(function_number)
	{
		case nn::prints:
		{
			Value v;
			ip.pop_stack(&v);
			char *str=(char*)ip.var_addr_to_mem_addr(v.u16);
			usart_write_str(str);
			break;
		}
	}
}


int main2();

int main()
{
	
	for(long i=0; i<1000000; i++)
		;
	usart_init();
	for(long i=0; i<1000000; i++)
		;
	while(1)
	{
		main2();
	}
}

const uint8 mem[] PROGMEM =
{	// Der Bytecode: Vom Compiler erzeugt (Hallo-Welt-Programm)
	118,   0,   1,   0, 129,   0, 145,   0, 254,   0,  20,   1,  42,   1, 160,   0, 161,   0,  11,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  98,   1, 142,   1, 142,   1, 142,   1, 142,   1, 
	142,   1, 142,   1, 142,   1, 142,   1,   0,   0,   0, 142,   1, 142,   1, 142,   1, 142,   1,   0, 
	  0,   1,   0,   1,   0,   1,   0,   1,   0,   1,   0,   1,   0,   1,   0,   1,   0,   1,   0,   1, 
	  0,   1,   0,   1,   0,   1,   0,   1,   0, 129,   0, 129,   0, 129,   0, 129,   0, 129,   0, 129, 
	  0, 129,   0, 129,   0, 129,   0, 129,   0, 129,   0, 145,   0, 145,   0, 145,   0, 145,   0, 145, 
	  0, 145,   0, 145,   0, 145,   0,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48, 
	 48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48,  48, 
	  2,  72,  97, 108, 108, 111,  44,  32,  87, 101, 108, 116,  32,  33,  13,  10,   0,   7,   0,  48, 
	  0,   1,   0,  51,   0,  39,   0,  28,   0,  21,   0,  19,   0,   5,   0,   3,   0,   0,   0,   0, 
	  0,   0,  97,  17,   0,  89,  56,  26, 128, 214, 132,  32,   5,   3,   0,   0,  81,  96,   0,  87, 
	  1,  49,   5,  17,   5,  18
};

uint8 get_code_nibble(PROGRAM_COUNTER_TYPE pc)
{
	return (pc&1) ? ((uint8)(pgm_read_byte(&mem[pc>>1])&15)) : ((uint8)((pgm_read_byte(&mem[pc>>1])>>4)&15));
}

uint8 get_code_byte(PROGRAM_COUNTER_TYPE pc)
{
	//gleichwertig wre: return (get_code_nibble(pc)<<4)+get_code_nibble(pc+1);
	if(0==(pc&1))
		return pgm_read_byte(&mem[pc>>1]);
	else
		return (((uint8)(pgm_read_byte(&mem[pc>>1])&15))<<4) + ((uint8)((pgm_read_byte(&mem[(pc+1)>>1])>>4)&15));
}


int main2()
{
	const uint16 stack_size=1024, memory_size=512; // wahrscheinlich wird tatschlich weniger Speicher bentigt.
	static uint8 stack[stack_size], memory[memory_size];

	BytecodeInterpreter::BytecodeInterpreter ip(stack, stack_size, memory, memory_size, get_code_nibble,
		get_code_byte, &extern_function_invoker);
	ip.execute_bytecode(400); // Funktion Main beginnt bei Nibble 400
	return 0;
}
