/*** uart.h ***/
// Aus www.mikrocontroller.net

#ifndef usart_h
#define usart_h

#define BAUD 9600UL          // Baudrate

#define F_CPU 16000000

#ifndef F_CPU
#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 14745600UL"
#define F_CPU 14745600UL    // Systemtakt in Hz
// Definition als unsigned long beachten
// Ohne UL ergibt Fehler in der Berechnung
#endif
 
// Berechnungen
#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD)      
// Fehler in Promille, 1000 = kein Fehler
 
#if ((BAUD_ERROR<990) || (BAUD_ERROR>1010))
#error Systematischer Fehler der Baudrate grsser 1% und damit zu hoch! 
#endif

void usart_init(void);
void usart_write_char(unsigned char c);
void usart_write_str(char *str);
void usart_write_long(char *str, long n);
void usart_write_ulong(char *str, unsigned long n);
void usart_write_int(char *str, int n);
void usart_write_uint(char *str, unsigned int n);
void usart_write_hex(char *str, unsigned long n);

#endif /* usart_h */
