// language_defines.h

//***********************************************************************************************************//
//***********************************************************************************************************//
//                                                                                                           //
// BytecodeInterpreter.h, BytecodeTargetedCompiler.h, language_defines.h, language_undefines.h, utils.h:     //
// These files contain a bytecode interpreter and a compiler converting a C-like program into bytecode.      //
//                                                                                                           //
// Copyright 2009 by Florian Knigstein, mail@virgusta.eu                                                    //
//                                                                                                           //
//      Commercial use of this code without my permission is prohibited.                                     //
//      You may use this program free of charge for non-commercial purposes provided you agree to the        //
//      following License:                                                                                   //
//                                                                                                           //
//      The Original Work is provided under this License on an "AS IS" BASIS and WITHOUT WARRANTY,           //
//      either express or implied, including, without limitation, the warranties of                          //
//      non-infringement, merchantability or fitness for a particular purpose. THE ENTIRE RISK AS TO THE     //
//      QUALITY OF THE ORIGINAL WORK IS WITH YOU. This DISCLAIMER OF WARRANTY constitutes an essential part  //
//      of this License. No license to the Original Work is granted by this License except under this        //
//      disclaimer.                                                                                          //
//                                                                                                           //
//      Limitation of Liability. Under no circumstances and under no legal theory, whether in tort           //
//      (including negligence), contract, or otherwise, shall the Licensor be liable to anyone for any       //
//      indirect, special, incidental, or consequential damages of any character arising as a result of      //
//      this License or the use of the Original Work including, without limitation, damages for loss of      //
//      goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages    //
//      or losses. This limitation of liability shall not apply to the extent applicable law prohibits such  //
//      limitation.                                                                                          //
//                                                                                                           //
//***********************************************************************************************************//
//***********************************************************************************************************//

// ***** ATTENTION *****
// This code is not well-tested. There may be several bugs.


// Im Folgenden wird die Bedeutung von uint8 und UINT8 sowie der anderen Typen "vertauscht". Da
// ein Vertauschen allein mit #defines nicht mglich ist, werden typedefs zur Hilfe genommen.
// Die Vertauschung wird durch #include "language_undefines" wieder rckgngig gemacht.
typedef bool                           AnotherNameForForBytecodeInterpreter_bool;
typedef BytecodeInterpreter::uint8     AnotherNameForBytecodeInterpreter_uint8;
typedef BytecodeInterpreter::uint16    AnotherNameForBytecodeInterpreter_uint16;
typedef BytecodeInterpreter::uint32    AnotherNameForBytecodeInterpreter_uint32;
typedef BytecodeInterpreter::uint64    AnotherNameForBytecodeInterpreter_uint64;
typedef BytecodeInterpreter::int8      AnotherNameForBytecodeInterpreter_int8;
typedef BytecodeInterpreter::int16     AnotherNameForBytecodeInterpreter_int16;
typedef BytecodeInterpreter::int32     AnotherNameForBytecodeInterpreter_int32;
typedef BytecodeInterpreter::int64     AnotherNameForBytecodeInterpreter_int64;
typedef BytecodeInterpreter::real_type AnotherNameForBytecodeInterpreter_real_type;

#define bool           BytecodeTargetedCompiler::__BOOL
#define uint8          BytecodeTargetedCompiler::__UINT8
#define uint16         BytecodeTargetedCompiler::__UINT16
#define uint32         BytecodeTargetedCompiler::__UINT32
#define uint64         BytecodeTargetedCompiler::__UINT64
#define int8           BytecodeTargetedCompiler::__INT8
#define int16          BytecodeTargetedCompiler::__INT16
#define int32          BytecodeTargetedCompiler::__INT32
#define int64          BytecodeTargetedCompiler::__INT64
#define real           BytecodeTargetedCompiler::__REAL

#define BOOL           AnotherNameForForBytecodeInterpreter_bool
#define UINT8          AnotherNameForBytecodeInterpreter_uint8
#define UINT16         AnotherNameForBytecodeInterpreter_uint16
#define UINT32         AnotherNameForBytecodeInterpreter_uint32
#define UINT64         AnotherNameForBytecodeInterpreter_uint64
#define INT8           AnotherNameForBytecodeInterpreter_int8
#define INT16          AnotherNameForBytecodeInterpreter_int16
#define INT32          AnotherNameForBytecodeInterpreter_int32
#define INT64          AnotherNameForBytecodeInterpreter_int64
#define REAL           AnotherNameForBytecodeInterpreter_real_type

// Schlsselwrter der zu kompilierenden C-hnlichen Sprache
#define begin          BYTECODE_TARGETED_COMPILER__BEGIN
#define end            BYTECODE_TARGETED_COMPILER__END
#define if             BYTECODE_TARGETED_COMPILER__IF
#define else           BYTECODE_TARGETED_COMPILER__ELSE
#define for            BYTECODE_TARGETED_COMPILER__FOR
#define dofor          BYTECODE_TARGETED_COMPILER__DOFOR
#define do             BYTECODE_TARGETED_COMPILER__DO
#define while          BYTECODE_TARGETED_COMPILER__WHILE
#define do_begin       BYTECODE_TARGETED_COMPILER__DO_BEGIN
#define end_while      BYTECODE_TARGETED_COMPILER__END_WHILE
#define break          BYTECODE_TARGETED_COMPILER__BREAK
#define continue       BYTECODE_TARGETED_COMPILER__CONTINUE
#define _nop_          ;BytecodeTargetedCompiler::expr();
#define TRUE           (BytecodeTargetedCompiler::expr(true))
#define FALSE          (BytecodeTargetedCompiler::expr(false))
#define goto           BYTECODE_TARGETED_COMPILER__GOTO
#define label          BYTECODE_TARGETED_COMPILER__label
#define cond           BytecodeTargetedCompiler::COND
#define array          BYTECODE_TARGETED_COMPILER__ARRAY
#define struct         BYTECODE_TARGETED_COMPILER__STRUCT
#define pointer        BYTECODE_TARGETED_COMPILER__POINTER
#define cpointer       BYTECODE_TARGETED_COMPILER__CPOINTER
#define declare_struct BYTECODE_TARGETED_COMPILER__DECLARE_STRUCT
#define struct_elem    BYTECODE_TARGETED_COMPILER__STRUCT_ELEM
#define end_struct     BYTECODE_TARGETED_COMPILER__END_STRUCT
#define declare_void_function    BYTECODE_TARGETED_COMPILER__DECLARE_VOID_FUNCTION
#define declare_function         BYTECODE_TARGETED_COMPILER__DECLARE_FUNCTION
#define declare_extern_void_function BYTECODE_TARGETED_COMPILER__DECLARE_EXTERN_VOID_FUNCTION
#define declare_extern_function  BYTECODE_TARGETED_COMPILER__DECLARE_EXTERN_FUNCTION
#define params              BytecodeTargetedCompiler::PARAMS
#define function            BYTECODE_TARGETED_COMPILER__function
#define void_function       BYTECODE_TARGETED_COMPILER__void_function
#define return              BytecodeTargetedCompiler::RETURN
#define param               BytecodeTargetedCompiler::param
#define local               BytecodeTargetedCompiler::local
#define var                 BytecodeTargetedCompiler::Variable
#define const               BytecodeTargetedCompiler::Constant
#define data_initialization BytecodeTargetedCompiler::DataInitialization
#define data_end_marker     BytecodeTargetedCompiler::DataEndMarker
#define sizeof              BytecodeTargetedCompiler::SIZEOF
#define cast                BytecodeTargetedCompiler::cast

#define BEGIN_GLOBAL_SCOPE  BYTECODE_TARGETED_COMPILER__BEGIN_GLOBAL_SCOPE
#define END_GLOBAL_SCOPE    BYTECODE_TARGETED_COMPILER__END_GLOBAL_SCOPE
